;Players
Const actor_warrior = 0
Const actor_wizard = 1

;Enemies
Const actor_skeleton = 2
Const actor_orc = 3
Const actor_icemonster = 4
Const actor_guard = 5
Const actor_mage = 6
Const actor_darkelf = 7
Const actor_iceguard = 8

;Boss
Const actor_boss = 6

Const collbox# = .75

Dim actor_data#(10,3)
Const actor_data_speed = 0
Const actor_data_weapon = 1
Const actor_data_health = 3

actor_data(actor_warrior,actor_data_speed) = 10
actor_data(actor_wizard,actor_data_speed) = 8
actor_data(actor_skeleton,actor_data_speed) = 6
actor_data(actor_orc,actor_data_speed) = 4
actor_data(actor_icemonster,actor_data_speed) = 4
actor_data(actor_mage,actor_data_speed) = 4
actor_data(actor_darkelf,actor_data_speed) = 4
actor_data(actor_guard,actor_data_speed) = 4
actor_data(actor_iceguard,actor_data_speed) = 5

actor_data(actor_warrior,actor_data_weapon) = weapon_sword
actor_data(actor_wizard,actor_data_weapon) = weapon_fireball
actor_data(actor_skeleton,actor_data_weapon) = weapon_axe
actor_data(actor_orc,actor_data_weapon) = weapon_tomahawk
actor_data(actor_icemonster,actor_data_weapon) = weapon_iceball
actor_data(actor_mage,actor_data_weapon) = weapon_fireball
actor_data(actor_darkelf,actor_data_weapon) = weapon_sword
actor_data(actor_guard,actor_data_weapon) = weapon_axe
actor_data(actor_iceguard,actor_data_weapon) = weapon_axe

actor_data(actor_warrior,actor_data_health) = 5
actor_data(actor_wizard,actor_data_health) = 5
actor_data(actor_skeleton,actor_data_health) = 1
actor_data(actor_orc,actor_data_health) = 1
actor_data(actor_icemonster,actor_data_health) = 2
actor_data(actor_mage,actor_data_health) = 5
actor_data(actor_darkelf,actor_data_health) = 5
actor_data(actor_guard,actor_data_health) = 2
actor_data(actor_iceguard,actor_data_health) = 10

Dim weapon_data#(8,3)
Const weapon_data_melee = 0
Const weapon_data_speed = 1
Const weapon_data_reload = 2

Const weapon_sword = 1
Const weapon_axe = 2
Const weapon_fireball = 3
Const weapon_iceball = 4
Const weapon_tomahawk = 5

weapon_data#(weapon_sword,weapon_data_melee) = 1
weapon_data#(weapon_axe,weapon_data_melee) = 1
weapon_data#(weapon_fireball,weapon_data_melee) = 0
weapon_data#(weapon_iceball,weapon_data_melee) = 0
weapon_data#(weapon_tomahawk,weapon_data_melee) = 0

weapon_data#(weapon_sword,weapon_data_speed) = 360 * 2
weapon_data#(weapon_axe,weapon_data_speed) = 360
weapon_data#(weapon_fireball,weapon_data_speed) = 10
weapon_data#(weapon_iceball,weapon_data_speed) = 5
weapon_data#(weapon_tomahawk,weapon_data_speed) = 5

weapon_data#(weapon_fireball,weapon_data_reload) = 1
weapon_data#(weapon_iceball,weapon_data_reload) = 2
weapon_data#(weapon_tomahawk,weapon_data_reload) = 3

Type typ_actor
	
	Field mesh
	Field mesh_shadow
	Field mesh_weapon
	Field class
	Field swordpos#
	Field swordacc#
	Field walkpos#
	Field movedir[4]
	Field frame
	Field hurt#
	Field health
	Field key
	
	Field attackdir
	Field target.typ_actor
	
	Field deathtimer#
	Field reloadtimer#
	Field retreattimer#
	
End Type

Type typ_scenery
	
	Field mesh
	Field class
	Field destroy
	
End Type

Type typ_particle
	
	Field mesh
	Field xs#
	Field ys#
	Field zs#
	Field class
	
End Type

Type typ_spawner
	
	Field class
	Field timer#
	Field entrance
	Field key
	
End Type

Type typ_projectile
	
	Field mesh
	Field class
	Field typ
	Field rotation#
	
End Type

Function typ_projectile_create(actor.typ_actor)
	
	Local projectile.typ_projectile = New typ_projectile
	projectile\mesh = CreateSprite()
	PositionEntity projectile\mesh,EntityX(actor\mesh),1,EntityZ(actor\mesh)
	RotateEntity projectile\mesh,0,(actor\frame * -90) + 180,0
	
	projectile\class = actor\class
	projectile\typ = actor_data(actor\class,actor_data_weapon)
	
	EntityTexture projectile\mesh, tex_projectile
	ScaleSprite projectile\mesh, 0.75, 0.75
	Select projectile\typ
		Case weapon_fireball
			EntityBlend projectile\mesh, 3
			EntityColor projectile\mesh, 255,128,64
			PlaySound snd_fireball
		Case weapon_iceball
			EntityBlend projectile\mesh, 3
			EntityColor projectile\mesh, 128,128,255		
		Case weapon_tomahawk
			ScaleSprite projectile\mesh, 0.5, 0.5			
			EntityTexture projectile\mesh, tex_projectile,1
	End Select
	
End Function

Function typ_projectile_handle(projectile.typ_projectile)
	
	Local actor.typ_actor
	
	MoveEntity projectile\mesh,0,0,weapon_data(projectile\typ,weapon_data_speed) * tick
	If projectile\typ = weapon_tomahawk Then 
		projectile\rotation = wrapvalue(projectile\rotation + (tick * 360),0,360)
		RotateSprite projectile\mesh,projectile\rotation
	EndIf
	
	If EntityX(projectile\mesh) > 8 Or EntityX(projectile\mesh) < -8 Or EntityZ(projectile\mesh) > 8 Or EntityZ(projectile\mesh) < -8 Then
		typ_projectile_destroy(projectile)
		Return
	EndIf
	
	For actor.typ_actor = Each typ_actor
		If incollbox(projectile\mesh,actor\mesh) And projectile\class <> actor\class  And actor\health > 0 Then
			If actor\class <> actor_guard And actor\class <> actor_darkelf
				
				If actor\class = actor_iceguard And actor\health <= 5
				Else
					typ_actor_hurt(actor)
				EndIf
				
			EndIf
			
				
			typ_projectile_destroy(projectile)
			Return
		EndIf
	Next
	
End Function

Function typ_projectile_clear()
	
	Local projectile.typ_projectile
	For projectile = Each typ_projectile
		typ_projectile_destroy(projectile)
	Next
	
End Function

Function typ_projectile_destroy(projectile.typ_projectile)
	
	FreeEntity projectile\mesh
	Delete projectile
	
End Function

Function typ_spawner_create(class,timer#,entrance,key = 0)
	
	Local spawner.typ_spawner = New typ_spawner
	spawner\class = class
	spawner\timer = timer#
	spawner\entrance = entrance
	spawner\key = key
	
End Function

Function typ_spawner_handle(spawner.typ_spawner)
	
	spawner\timer = spawner\timer - tick
	If spawner\timer < 0
		Select spawner\entrance
			Case 0
				X =-7
				Z = 0
			Case 1
				X = 0
				Z = 7
			Case 2
				X = 7 
				Z = 0	
			Case 3
				X = 0
				Z = -7
		End Select
		
		typ_actor_create(spawner\class,X,Z,spawner\key)
		Delete spawner
		
	EndIf
	
	
End Function

Function typ_particle_create(class,x,z)
	
	Local particle.typ_particle = New typ_particle
	particle\mesh = CreateSprite()
	ScaleSprite particle\mesh, 0.25, 0.25
	RotateSprite particle\mesh, Rand(360)
	EntityTexture particle\mesh, tex_particles, class
	PositionEntity particle\mesh,x,1,z
	particle\xs# = Rnd(-3,3)
	particle\zs# = Rnd(-3,3)
	particle\ys# = Rnd(-1.5,3)
	particle\class = class
	Select particle\class
		Case 0
		Case 1
			EntityBlend particle\mesh,3
		Case 2
			EntityAlpha particle\mesh,0.75
	End Select
	
End Function

Function typ_particle_handle(particle.typ_particle)
	
	TranslateEntity particle\mesh,particle\xs * tick,particle\ys * tick,particle\zs * tick
	particle\ys = particle\ys - (tick * 9.8)
	
	If EntityX(particle\mesh) < -8 And particle\xs < 0 Then particle\xs = particle\xs * -1
	If EntityX(particle\mesh) > 8 And particle\xs > 0 Then particle\xs = particle\xs * -1
	If EntityZ(particle\mesh) < -8 And particle\zs < 0 Then particle\zs = particle\zs * -1
	If EntityZ(particle\mesh) < 8 And particle\zs > 0 Then particle\zs = particle\zs * -1
	
	If EntityY(particle\mesh) < 0.1 Then 
		
		If particle\class > 0
			FreeEntity particle\mesh
			Delete particle
		Else
			particle\xs = 0
			particle\ys = 0
			particle\zs = 0
		EndIf
	EndIf
	
End Function


Function typ_scenery_create(class,x,z)
	
	Local scenery.typ_scenery = New typ_scenery
	scenery\mesh = CreateSprite()
	PositionEntity scenery\mesh,(x * 2) - 8,1,(z * 2) - 8
	EntityTexture scenery\mesh, tex_scenery, class
	SpriteViewMode scenery\mesh, 2
	
End Function

Function typ_actor_create.typ_actor(class,x,z,key = 0)
	
	Local actor.typ_actor = New typ_actor
	actor\mesh = CreateSprite()
	actor\mesh_shadow = CreateSprite(actor\mesh)
	actor\mesh_weapon = CreateSprite()
	PositionEntity actor\mesh_weapon,0,-100,0
	actor\class = class
	
	SpriteViewMode actor\mesh, 2
	
	PositionEntity actor\mesh,x,0,z
	EntityTexture actor\mesh_shadow,tex_shadow
	SpriteViewMode actor\mesh_shadow, 2
	MoveEntity actor\mesh_shadow, 0, -0.95, 0
	RotateEntity actor\mesh_shadow,90,0,0
	EntityAlpha actor\mesh_shadow, 0.5
	ScaleSprite actor\mesh_shadow, 0.5, .5
	
	SpriteViewMode actor\mesh_weapon,2
	ScaleSprite actor\mesh_weapon, .5, .5
	
	actor\health = actor_data(actor\class,actor_data_health)
	actor\key = key
	
	If actor\class > actor_wizard
		actor\reloadtimer = Rnd(0,2)
	EndIf
	
	;Boss type
	If actor\key = 1 And actor\class < actor_mage And actor\class <> actor_icemonster Then
		EntityColor actor\mesh,255,255,0
	EndIf
	
	
	
	Return actor
	
End Function

Function typ_actor_move(actor.typ_actor,xdir,ydir)
	
	Local scenery.typ_scenery
	Local actor2.typ_actor
	
	;XMove
	If xdir <> 0
		TranslateEntity actor\mesh,xdir * tick * actor_data(actor\class,actor_data_speed),0,0
		For scenery.typ_scenery = Each typ_scenery
			If incollbox(actor\mesh,scenery\mesh)
				If EntityX(actor\mesh) > EntityX(scenery\mesh)
					PositionEntity actor\mesh, EntityX(scenery\mesh) + collbox,1,EntityZ(actor\mesh)
				Else
					PositionEntity actor\mesh, EntityX(scenery\mesh) - collbox,1,EntityZ(actor\mesh)
				EndIf
			EndIf
		Next
		For actor2.typ_actor = Each typ_actor
			If incollbox(actor\mesh,actor2\mesh) And actor <> actor2 And actor2\health > 0
				If EntityX(actor\mesh) > EntityX(actor2\mesh)
					PositionEntity actor\mesh, EntityX(actor2\mesh) + collbox,1,EntityZ(actor\mesh)
				Else
					PositionEntity actor\mesh, EntityX(actor2\mesh) - collbox,1,EntityZ(actor\mesh)
				EndIf
			EndIf
		Next
	EndIf
	
	
	;YMove
	If ydir <> 0
		TranslateEntity actor\mesh,0,0,ydir * tick * actor_data(actor\class,actor_data_speed)
		For scenery.typ_scenery = Each typ_scenery
			If incollbox(actor\mesh,scenery\mesh)
				If EntityZ(actor\mesh) > EntityZ(scenery\mesh)
					PositionEntity actor\mesh, EntityX(actor\mesh),1,EntityZ(scenery\mesh) + collbox
				Else
					PositionEntity actor\mesh, EntityX(actor\mesh),1,EntityZ(scenery\mesh) - collbox
				EndIf
			EndIf
		Next
		For actor2.typ_actor = Each typ_actor
			If incollbox(actor\mesh,actor2\mesh) And actor <> actor2 And actor2\health > 0
				If EntityZ(actor\mesh) > EntityZ(actor2\mesh)
					PositionEntity actor\mesh, EntityX(actor\mesh),1,EntityZ(actor2\mesh) + collbox
				Else
					PositionEntity actor\mesh, EntityX(actor\mesh),1,EntityZ(actor2\mesh) - collbox
				EndIf
			EndIf			
		Next
	EndIf
	
	If actor\class = actor_iceguard
		If EntityY(actor\mesh) < 2.5
			PositionEntity actor\mesh,EntityX(actor\mesh),2.5,EntityZ(actor\mesh)
		EndIf
	EndIf
	
	;CHECK BOUNDARY COLLISION
	PositionEntity actor\mesh,limitvalue(EntityX(actor\mesh),-7,7),1,limitvalue(EntityZ(actor\mesh),-7,7)
	
End Function

Function typ_actor_destroy(actor.typ_actor)
	
	FreeEntity actor\mesh
	FreeEntity actor\mesh_weapon
	Delete actor
	
End Function

Function incollbox(entity1,entity2,coll# = -1)
	
	If coll = -1 Then coll = collbox
	
	If EntityX(entity1) < EntityX(entity2) + coll And EntityX(entity1) > EntityX(entity2) - coll And EntityZ(entity1) < EntityZ(entity2) + coll And EntityZ(entity1) > EntityZ(entity2) - coll
		Return 1
	EndIf
	
End Function

Function typ_actor_handle(actor.typ_actor)
	
	Local scenery.typ_scenery
	Local total
	Local a
	
	If actor\health <= 0
		
		If actor\deathtimer = 0
			PlaySound(snd_die)
			Select actor\class
				Case actor_skeleton
					For a = 0 To 9
						typ_particle_create(0,EntityX(actor\mesh),EntityZ(actor\mesh))
					Next	
			End Select
		EndIf
		
		actor\deathtimer = actor\deathtimer + tick
		
		If actor\deathtimer > 1
			RotateEntity actor\mesh, 90, 0, 0
			PositionEntity actor\mesh, EntityX(actor\mesh),.1,EntityZ(actor\mesh)
			PositionEntity actor\mesh_weapon, EntityX(actor\mesh),.2,EntityZ(actor\mesh)
		Else
			RotateEntity actor\mesh, 90 * actor\deathtimer, 0, 0
			PositionEntity actor\mesh, EntityX(actor\mesh),1.1 - actor\deathtimer,EntityZ(actor\mesh)			
			PositionEntity actor\mesh_weapon, EntityX(actor\mesh),1.2 - actor\deathtimer,EntityZ(actor\mesh)
		EndIf
		
		If actor\key = 1 Then 
			ShowEntity spr_key
			PositionEntity spr_key,EntityX(actor\mesh),1,EntityZ(actor\mesh)
			keystate = 1
		EndIf
		
		If actor\class <= actor_wizard And actor\deathtimer > 4 Then exitlevel = 2
			
		Return
	EndIf
	
	For a = 0 To 3
		actor\movedir[a] = 0
	Next
	
	
	If actor = player
		
		actor\movedir[0] = KeyDown(208)
		actor\movedir[1] = KeyDown(203)
		actor\movedir[2] = KeyDown(200)
		actor\movedir[3] = KeyDown(205)
		
		If actor\swordacc = 0
			typ_actor_handle_attack(actor)	
			If KeyHit(44) Then 
				PlaySound snd_sword
				actor\swordacc = 1
				actor\attackdir = -Sgn(actor\swordpos)
				If actor\attackdir = 0 Then actor\attackdir = 1
			EndIf
		Else
			typ_actor_handle_attack(actor,actor\attackdir)
		EndIf
		
		
		If keystate = 1 And incollbox(spr_key,actor\mesh) Then 
			If exitlevel = 0 Then PlaySound snd_key
			exitlevel = 1
		EndIf
			
	Else
		
		Local retreat = 0
		actor\retreattimer = actor\retreattimer - tick
		If actor\retreattimer < 0 Then actor\retreattimer = 0
		
		actor\target.typ_actor = typ_actor_hunt(actor)
		If actor\target = Null Then actor\target.typ_actor = typ_actor_hunt(actor,1)
		
		If actor\target <> Null
			
			If (typ_actor_side(actor\target) <> typ_actor_side(actor)) Or EntityDistance(actor\mesh,actor\target\mesh) > 4
				If EntityZ(actor\target\mesh) < EntityZ(actor\mesh) - (collbox / 2) Then actor\movedir[0] = 1
				If EntityZ(actor\target\mesh) > EntityZ(actor\mesh) + (collbox / 2) Then actor\movedir[2] = 1
				If EntityX(actor\target\mesh) < EntityX(actor\mesh) - (collbox / 2) Then actor\movedir[1] = 1
				If EntityX(actor\target\mesh) > EntityX(actor\mesh) + (collbox / 2) Then actor\movedir[3] = 1
			EndIf
			
			If actor\retreattimer > 0 Then
				temp = actor\movedir[0]
				actor\movedir[0] = actor\movedir[2]
				actor\movedir[2] = temp
				temp = actor\movedir[1]
				actor\movedir[1] = actor\movedir[3]
				actor\movedir[3] = temp	
			EndIf
			
			;Init attack!
			If typ_actor_side(actor) <> typ_actor_side(actor\target) And EntityDistance(actor\mesh,actor\target\mesh) < 3
				typ_actor_handle_attack(actor,actor\attackdir)
			Else
				typ_actor_handle_attack(actor)
			EndIf
			
		EndIf			
		
	EndIf
	
	For a = 0 To 3
		If actor\movedir[a] > 0 Then 
			If actor <> player Or KeyDown(42) = 0 Then actor\frame = a
			actor\walkpos# = actor\walkpos# + (tick * 5)
			total = total + 1
		EndIf
		If Int(actor\walkpos#) => 3 Then actor\walkpos# = 1  
	Next
	If total = 0 Then actor\walkpos# = 0
	
	;Move and animate the actor
	typ_actor_move(actor,actor\movedir[3] - actor\movedir[1],actor\movedir[2] - actor\movedir[0])
	If actor\class <> actor_iceguard
		EntityTexture actor\mesh, tex_actors(actor\class), Int(actor\walkpos) + (actor\frame * 3)
	Else
		EntityTexture actor\mesh, tex_actors(actor_guard), Int(actor\walkpos) + (actor\frame * 3)
		If actor\health > 5 Then
			EntityColor actor\mesh,255 - ((actor\health - 5) * 255/5),0,255 - ((10 - actor\health) * 255/10)
		Else
			EntityColor actor\mesh,255,0,0
		EndIf
	EndIf
		
	;Is the actor hurt
	actor\hurt# = actor\hurt# - tick
	If actor\hurt# < 0 Then actor\hurt# = 0
	If actor\hurt# > 0 And (MilliSecs() Mod 200) > 100
		HideEntity actor\mesh
	Else
		ShowEntity actor\mesh
	EndIf
	
	;Place the Camera
	If actor = player Then PositionEntity eyes,limitvalue(EntityX(eyes),EntityX(actor\mesh) - 3,EntityX(actor\mesh) + 3),6,limitvalue(EntityZ(eyes),EntityZ(actor\mesh) - 3 - 10,EntityZ(actor\mesh) + 3 - 10)
	
End Function

Function typ_actor_handle_attack(actor.typ_actor,attackdir = 0)
	
	Local a
	Local actor2.typ_actor
	Local scenery.typ_scenery
	Local weaponspeed = weapon_data(actor_data(actor\class,actor_data_weapon),weapon_data_speed)
	
	EntityTexture actor\mesh_weapon, tex_weapons, actor_data(actor\class,actor_data_weapon)
	
	
	;IF THE CHARACTER IS ARMED WITH A MELEE WEAPON
	If weapon_data(actor_data(actor\class,actor_data_weapon),weapon_data_melee)
		
		ShowEntity actor\mesh_weapon
		
	;Check for swing
		If attackdir <> actor\attackdir Or attackdir = 0 Then 
			actor\swordacc = 0
			actor\attackdir = attackdir
			If actor\attackdir = 0 Then actor\attackdir = 1
		Else
			actor\swordpos# = actor\swordpos# + (actor\attackdir * weaponspeed * tick)
			actor\swordacc = actor\swordacc + (weaponspeed * tick * 0.5)
		EndIf
		
		If Abs(actor\swordpos#) > 135
			actor\swordacc = 0
			actor\swordpos# = limitvalue(actor\swordpos#,-135,135)
			If actor\attackdir = 1
				actor\attackdir = -1
			Else
				actor\attackdir = 1
			EndIf
		EndIf
		
	;Check for hits
		If actor\swordacc# > 90
			
			For scenery.typ_scenery = Each typ_scenery
				If incollbox(actor\mesh_weapon,scenery\mesh,1) And scenery\destroy = 0
					scenery\destroy = 1
					EntityTexture scenery\mesh, tex_scenery, scenery\class + 8
					For a = 0 To Rand(1,4)
						typ_particle_create(1,EntityX(actor\mesh_weapon),EntityZ(actor\mesh_weapon))
					Next
				EndIf
			Next
			For actor2.typ_actor = Each typ_actor
				If incollbox(actor\mesh_weapon,actor2\mesh,1) And typ_actor_side(actor) <> typ_actor_side(actor2) And actor2\health > 0 And actor2\class <> actor_icemonster And actor2\class <> actor_mage
					
					If actor2\class = actor_iceguard And actor2\health > 5
						
					Else
					
						If typ_actor_hurt(actor2)
							For a = 0 To Rand(1,4)
								typ_particle_create(1,EntityX(actor\mesh_weapon),EntityZ(actor\mesh_weapon))
							Next
						EndIf
					
					EndIf
					
				EndIf
			Next	
		EndIf
		
	;Position the sword
		PositionEntity actor\mesh_weapon,EntityX(actor\mesh),EntityY(actor\mesh),EntityZ(actor\mesh)
		RotateEntity actor\mesh_weapon,0,(actor\frame * -90) + 180 + actor\swordpos,0
		MoveEntity actor\mesh_weapon,0,0,0.75
		TurnEntity actor\mesh_weapon,90,0,0
		
	;The actor is armed with a projectile weapon
	Else
		
		HideEntity actor\mesh_weapon
		
		actor\reloadtimer = actor\reloadtimer - tick#
		If actor\reloadtimer < 0
			If player = actor
				If KeyHit(44) Then 
					typ_projectile_create(actor)
					actor\reloadtimer = 0.25
				EndIf
			Else
				typ_projectile_create(actor)
				actor\reloadtimer = weapon_data(actor_data(actor\class,actor_data_weapon),weapon_data_reload)
			EndIf
		EndIf
		
	EndIf
	
End Function

Function typ_actor_hunt.typ_actor(actor1.typ_actor,force = 0)
	
	Local actor2.typ_actor
	Local best.typ_actor
	
	For actor2.typ_actor = Each typ_actor
		
		If actor2 <> actor1 And actor2\health > 0
			If (typ_actor_side(actor1.typ_actor) <> typ_actor_side(actor2.typ_actor)) Or force = 1
				
				If best = Null
					best = actor2
				Else
					If EntityDistance(actor1\mesh,actor2\mesh) < EntityDistance(actor1\mesh,best\mesh)
						best = actor2
					EndIf
				EndIf
				
			EndIf
		EndIf
		
	Next
	
	Return best
	
End Function

Function typ_actor_hurt(actor.typ_actor)
	
	If actor\hurt <= 0
		
		If (actor\class <= actor_wizard And player <> actor)
			
			actor\retreattimer = 5
			
		Else
			
			Select actor\class
				Case actor_skeleton
					
				Case actor_icemonster
				Default
					For a = 0 To Rand(1,4)
						typ_particle_create(2,EntityX(actor\mesh),EntityZ(actor\mesh))
					Next
			End Select
			
			actor\health = actor\health - 1
			If actor\health > 0 Then actor\hurt = 0.5
			Return 1
		EndIf
		
	EndIf
	
	Return 0
	
End Function

Function typ_actor_drawhealth()
	
	If player <> Null
		For a = 1 To player\health
			DrawImage img_health,(a * 32),768 - 32 - 64
		Next
	EndIf
	
End Function

Function typ_actor_side(actor.typ_actor)
	
	If actor\class <= actor_wizard Then Return 0
	Return 1
	
End Function

Function typ_actor_clear()
	
	Local actor.typ_actor
	
	For actor = Each typ_actor
		typ_actor_destroy(actor)
	Next
	
End Function

Function typ_particle_clear()
	
	Local particle.typ_particle
	
	For particle = Each typ_particle
		FreeEntity particle\mesh
		Delete particle
	Next
	
End Function

Function typ_scenery_clear()
	
	Local scenery.typ_scenery
	
	For scenery = Each typ_scenery
		FreeEntity scenery\mesh
		Delete scenery
	Next
	
End Function

Function typ_spawner_clear()
	
	Local spawner.typ_spawner
	
	For spawner = Each typ_spawner
		Delete spawner
	Next
	
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D