AppTitle "Heart of Ice"
;By Erik Hogan

sound = LoadSound("music.ogg")
LoopSound(sound)
PlaySound(sound)

Global snd_die = LoadSound("die.wav")
Global snd_key = LoadSound("key.wav")
;Global snd_fireball = LoadSound("fireball.wav")
;Global snd_sword = LoadSound("sword.wav")

Graphics3D 1024,768,32,0

;Arrays
Dim tex_actors(10)
Dim str_areas$(8)
str_areas(0) = "Dungeon"
str_areas(1) = "Barracks"
str_areas(2) = "Armoury"
str_areas(3) = "Library"
str_areas(4) = "Courtyard"
str_areas(6) = "Lair of the Vampire Mage"
str_areas(7) = "Lair of the Dark Elf"
str_areas(8) = "The Final Challenge"


;Includes
Include "actors.bb"

;Init Camera
Global eyes = CreateCamera()
CameraRange eyes,0.1,1000
Global eyesphere = CreateCube(eyes)
EntityBlend eyesphere, 2
FlipMesh eyesphere
EntityColor eyesphere, 0,0,0

RotateEntity eyes, 30, 0, 0
SetBuffer BackBuffer()
AmbientLight 255,255,255

;Init timekeeping
Global cycles = 60
Global tick# = 1 / Float cycles
Global timer = CreateTimer(cycles)
SeedRnd(MilliSecs())

Global player.typ_actor

Global tex_temp = LoadTexture("textures\temp.png",2 + 16 + 32)
For a = 0 To 9
	tex_actors(a) = LoadAnimTexture("textures\actor" + a + ".png",2 + 16 + 32,64,64,0,12)
Next
Global tex_snow = LoadTexture("textures\snow.png")
ScaleTexture tex_snow,10,10
Global tex_shadow = LoadTexture("textures\shadow.png",2)
Global tex_weapons = LoadAnimTexture("textures\weapons.png",2 + 16 + 32,32,32,0,10)
Global tex_particles = LoadAnimTexture("textures\particles.png",2 + 16 + 32,32,32,0,4)
Global tex_projectile = LoadAnimTexture("textures\projectile.png",2,32,32,0,2)

Global spr_key = LoadSprite("textures\key.png",2)

Global img_title1 = LoadImage("textures\title1.png")
Global img_title2 = LoadImage("textures\title2.png")
Global img_gameover = LoadImage("textures\gameover.png")
Global img_ending = LoadAnimImage("textures\ending.png",800,80,0,10)
Global img_numbers = LoadAnimImage("textures\numbers.png",64,64,0,10)

MidHandle img_title1
MidHandle img_title2
MidHandle img_gameover

ScaleSprite spr_key,0.5,0.5
SpriteViewMode spr_key, 2
EntityFX spr_key, 16
Global img_health = LoadImage("textures\health.png")

Global mesh_plane = CreateMesh()
Global mesh_walls = CreateMesh()
Global mesh_door = CreateMesh()
Global mesh_castle = CreateMesh()
Global mesh_floor = CreateMesh()
Global tex_walls = LoadAnimTexture("textures\walls.png",0,32,32,0,10)
Global tex_floors
Global tex_doors = LoadAnimTexture("textures\doors.png",0,32,32,0,10)
Global tex_scenery = LoadAnimTexture("textures\scenery.png",2,32,32,0,16)

makeblocks()

Global monologue$
Global keystate = 0
Local level = 0
Global exitlevel = 0
Global character = actor_warrior
Local levelstate = 0
Local gamestate = 0

Repeat
	
	Select gamestate 
		Case 0
			showimage(img_title1)
			If KeyHit(1) Then End
			showimage(img_title2)
			level = 0
			gamestate = 1
			For a = 0 To 7
				If KeyHit(a + 1) Then level = a
			Next
		Case 1
			levelstate = playlevel(level)
			If levelstate = 1 And level = 7 Then levelstate = 4
			Select levelstate
				Case 1
					level = level + 1
				Case 2
					showimage(img_gameover)
					gamestate = 0
				Case 3
					gamestate = 0
				Case 4
					callending()
					gamestate = 0
			End Select			
	End Select
			
	
Forever

Function callending()
	
	Local plane = CreatePlane()
	EntityTexture plane, tex_snow
	
	Local char1 = CreateSprite()
	PositionEntity char1,-0.5,1,-2
	
	Local char2 = CreateSprite()
	PositionEntity char2, 0.5,1,-2
	
	HideEntity mesh_floor
	HideEntity mesh_door
	HideEntity mesh_walls
	HideEntity mesh_plane
	HideEntity mesh_castle
	HideEntity spr_key
	
	
	PositionEntity eyes,0,6,-10
	
	Color 0,0,0
	
	Repeat
		
		snowpos# = snowpos# + (tick / 10)
		PositionTexture tex_snow,0,snowpos#
		
		If MilliSecs() Mod 1000 > 500
			EntityTexture char1, tex_actors(0), 1
			EntityTexture char2, tex_actors(1), 2
		Else
			EntityTexture char1, tex_actors(0), 2
			EntityTexture char2, tex_actors(1), 1			
		EndIf
		
		If exitscene = 0
			eyevar = eyevar + 255 * tick
		Else
			eyevar = eyevar - 255 * tick
		EndIf
		
		If eyevar > 255 Then eyevar = 255
		EntityColor eyesphere, eyevar, eyevar, eyevar
		
		If KeyHit(1) Then exitscene = 1
		
		RenderWorld()
		
		scenetimer# = scenetimer# + tick
		If Int(scenetimer# / 5) > 9 Then
			exitscene = 1
		Else
			DrawImage img_ending,112,8,Int(scenetimer# / 5)
		EndIf
		
		Flip
		WaitTimer(timer)
		
	Until exitscene <> 0 And eyevar = 255
	
	Color 255,255,255
	
	FreeEntity plane
	FreeEntity char1
	FreeEntity char2
	
	ShowEntity spr_key
	
End Function

Function showimage(img)
	
	FlushKeys()
	Cls
	DrawImage img,512,384
	Flip()
	WaitKey()
	
End Function

Function playlevel(scene)
	
	Local eyevar# = 0
	
	HideEntity spr_key
	keystate = 0
	exitlevel = 0
	
	Local leveltimer# = 30
	If scene = 7 Then leveltimer# = 45
	
	player = typ_actor_create(character,0,-5)
	
	buildscene(scene)
	
	Repeat
		
		If KeyHit(45)
			
			Select character
				Case actor_warrior
					character = actor_wizard
				Case actor_wizard
					character = actor_warrior
			End Select
			
			player\class = character
		EndIf
			
		TurnEntity spr_key, 0, 90 * tick, 0
		
		If exitlevel = 0
			eyevar = eyevar + 255 * tick
		Else
			eyevar = eyevar - 255 * tick
		EndIf
		
		If eyevar > 255 Then eyevar = 255
		EntityColor eyesphere, eyevar, eyevar, eyevar
			
		leveltimer# = leveltimer# - tick
		
		If KeyHit(1) Then exitlevel = 3
		If KeyHit(49) Then exitlevel = 1
		If leveltimer# < 0 Then exitlevel = 2
		
		Local actor.typ_actor
		Local particle.typ_particle
		Local spawner.typ_spawner
		Local projectile.typ_projectile
		
		For spawner.typ_spawner = Each typ_spawner
			typ_spawner_handle(spawner)
		Next
		For actor.typ_actor = Each typ_actor
			typ_actor_handle(actor)
		Next
		For particle.typ_particle = Each typ_particle
			typ_particle_handle(particle)
		Next
		For projectile.typ_projectile = Each typ_projectile
			typ_projectile_handle(projectile)
		Next
		
		RenderWorld()
		
		typ_actor_drawhealth()
		;Text 512,16,str_areas(scene),1,1
		;Text 512,32,"Time Left:" + Int(leveltimer#),1,1
		
		temptimer = Int(leveltimer)
		If temptimer > 9 Then DrawImage img_numbers,1024 - 128,0,temptimer / 10
		If temptimer > 0 Then DrawImage img_numbers,1024 - 64,0,temptimer Mod 10
		
		Flip
		WaitTimer(timer)
		
	Until exitlevel <> 0 And eyevar <= 0
	
	;clearlevel stuff
	typ_actor_clear()
	typ_particle_clear()
	typ_scenery_clear()
	typ_spawner_clear()
	typ_projectile_clear()
	
	Return exitlevel
	
End Function


Function makeblocks()
	
	Local surface
	Local v1
	Local v2
	Local v3
	Local v4
	Local v1a
	Local v1b
	Local v2a
	Local v2b
	Local v3a
	Local v3b
	Local v4a
	Local v4b
	
	;Door
	mesh_door = CreateMesh()
	surface = CreateSurface(mesh_door)
	v1 = AddVertex(surface,-2,4,7.95,0,0)
	v2 = AddVertex(surface, 2,4,7.95,2,0)
	v3 = AddVertex(surface,-2,0,7.95,0,2)
	v4 = AddVertex(surface, 2,0,7.95,2,2)
	AddTriangle(surface,v1,v2,v3)
	AddTriangle(surface,v2,v4,v3)
	v1 = AddVertex(surface,-7.95,4,-2,0,0)
	v2 = AddVertex(surface,-7.95,4,2,2,0)
	v3 = AddVertex(surface,-7.95,0,-2,0,2)
	v4 = AddVertex(surface,-7.95,0,2,2,2)
	AddTriangle(surface,v1,v2,v3)
	AddTriangle(surface,v2,v4,v3)
	v1 = AddVertex(surface,7.95,4,2,0,0)
	v2 = AddVertex(surface,7.95,4,-2,2,0)
	v3 = AddVertex(surface,7.95,0,2,0,2)
	v4 = AddVertex(surface,7.95,0,-2,2,2)
	AddTriangle(surface,v1,v2,v3)
	AddTriangle(surface,v2,v4,v3)	
	;Ground
	;mesh_plane = CreatePlane()
	surface = CreateSurface(mesh_plane)
	v1 = AddVertex(surface,-33,0, 33,0,0)
	v2 = AddVertex(surface, 33,0, 33,60,0)
	v3 = AddVertex(surface,-33,0,-33,0,60)
	v4 = AddVertex(surface, 33,0,-33,60,60)
	AddTriangle surface,v1,v2,v3
	AddTriangle surface,v2,v4,v3
	
	;Castle Facade
	surface = CreateSurface(mesh_castle)
	v1 = AddVertex(surface,-30,10,8,0,0)
	v2 = AddVertex(surface,30,10,8,20,0)
	v3 = AddVertex(surface,-30,0,8,0,4)
	v4 = AddVertex(surface,30,0,8,20,4)
	AddTriangle(surface,v1,v2,v3)
	AddTriangle(surface,v2,v4,v3)	
	
	;Inside Castle
	surface = CreateSurface(mesh_walls)
	v1a = AddVertex(surface,-8,4,8,0,0)
	v2a = AddVertex(surface, 8,4,8,4,0)
	v3a = AddVertex(surface,-8,0,8,0,2)
	v4a = AddVertex(surface, 8,0,8,4,2)
	v1b = AddVertex(surface,-8,4,-8,4,0)
	v2b = AddVertex(surface, 8,4,-8,0,0)
	v3b = AddVertex(surface,-8,0,-8,4,2)
	v4b = AddVertex(surface, 8,0,-8,0,2)		
	AddTriangle(surface,v1a,v2a,v3a)
	AddTriangle(surface,v2a,v4a,v3a)
	AddTriangle(surface,v1b,v1a,v3b)
	AddTriangle(surface,v1a,v3a,v3b)
	AddTriangle(surface,v2a,v2b,v4b)
	AddTriangle(surface,v2a,v4b,v4a)
	
	;Castle Floor
	surface = CreateSurface(mesh_floor)
	v1 = AddVertex(surface,-8,0, 8,0,0)
	v2 = AddVertex(surface, 8,0, 8,20,0)
	v3 = AddVertex(surface,-8,0,-8,0,20)
	v4 = AddVertex(surface, 8,0,-8,20,20)
	AddTriangle surface,v1,v2,v3
	AddTriangle surface,v2,v4,v3
	
End Function

Function buildscene(scene)
	
	EntityTexture mesh_door,tex_doors,scene
	
	If tex_floors > 0 Then FreeImage tex_floors : tex_floors = 0
	tex_floors = LoadTexture("textures\floor" + scene + ".png")
	If tex_floors = 0 Then LoadTexture("textures\floor0.png")
	ScaleTexture tex_floors,20,20
	EntityTexture mesh_floor, tex_floors
	EntityTexture mesh_plane, tex_floors
	
	;f tex_walls > 0 Then FreeImage tex_walls
	;tex_walls = LoadTexture("textures\wall" + scene + ".png")
	;If tex_walls = 0 Then LoadTexture("textures\wall0.png")
	EntityTexture mesh_walls,tex_walls, scene
	EntityTexture mesh_castle,tex_walls, scene
	
	ShowEntity mesh_walls
		ShowEntity mesh_floor
		HideEntity mesh_castle
		HideEntity mesh_plane
		ShowEntity mesh_door
		
		Select scene
			Case 0
				
				;LEVEL ONE - DUNGEON (0:00-0:30)
				;BOSS Skeleton
				
				typ_spawner_create(actor_skeleton,3,1)
				typ_spawner_create(actor_orc,6,0)
				
				typ_spawner_create(actor_skeleton,9,1)
				typ_spawner_create(actor_skeleton,9,3)
				
				typ_spawner_create(actor_orc,12,0)
				typ_spawner_create(actor_orc,12,2)			
				
				typ_spawner_create(actor_skeleton,15,1,1)
				
			Case 1
				
				;LEVEL TWO - BARRACKS (0:30-1:00)
				;Skeletons And Orcs together
				;Boss Orc
				
				typ_spawner_create(actor_skeleton,1,0)
				typ_spawner_create(actor_orc,2,2)
				
				typ_spawner_create(actor_skeleton,6,1)
				typ_spawner_create(actor_orc,7,3)
				
				typ_spawner_create(actor_skeleton,9,2)
				typ_spawner_create(actor_skeleton,10,3)
				typ_spawner_create(actor_skeleton,11,0)
				typ_spawner_create(actor_skeleton,12,1)
				
				typ_spawner_create(actor_orc,17,2)
				typ_spawner_create(actor_orc,18,3)
				typ_spawner_create(actor_orc,19,0)
				typ_spawner_create(actor_orc,20,1,1)
				
			Case 2
				
				;LEVEL THREE - ARMOURY (1:00-1:30)
				;More Skeletons And Orcs together
				;Boss guard
				
				For a = 0 To 7
					typ_spawner_create(Rand(actor_orc,actor_skeleton),2 + (a * 2),Rand(0,3))
				Next
					
				typ_spawner_create(actor_guard,15,1,1)
				
			Case 3
				
				;LEVEL FOUR - LIBRARY (1:30-2:00)
				;More guards at the start. More Skeletons And orcs Together. Introduce icemen at the End.
				
				typ_spawner_create(actor_guard,1,1)
				typ_spawner_create(actor_guard,3,1)
				typ_spawner_create(actor_guard,5,1)
				typ_spawner_create(actor_guard,7,1)
				
				typ_spawner_create(actor_skeleton,9,0)
				typ_spawner_create(actor_orc,10,1)
				typ_spawner_create(actor_skeleton,11,2)
				typ_spawner_create(actor_orc,12,3)				
				
				typ_spawner_create(actor_icemonster,15,1,1)
				
			Case 4
				
				;LEVEL FIVE - COURTYARD (2:30-3:00)
				;Guards and Icemonsters only
				
				typ_spawner_create(Rand(actor_icemonster,actor_guard),2,0)
				typ_spawner_create(Rand(actor_icemonster,actor_guard),4,1)
				typ_spawner_create(Rand(actor_icemonster,actor_guard),6,2)
				typ_spawner_create(Rand(actor_icemonster,actor_guard),8,3)
				typ_spawner_create(Rand(actor_icemonster,actor_guard),10,3)
				typ_spawner_create(Rand(actor_icemonster,actor_guard),12,2)
				typ_spawner_create(Rand(actor_icemonster,actor_guard),14,1)
				typ_spawner_create(Rand(actor_icemonster,actor_guard),18,0)				
				typ_spawner_create(Rand(actor_icemonster,actor_guard),20,1,1)
				
			Case 5
				
				
				;LEVEL SEVEN - HALLWAY (3:30-4:00)
				;Vampire Mage guarded by orcs And icemen (Projectiles)
				
				typ_spawner_create(actor_mage,1,1,1)
				typ_spawner_create(Rand(actor_orc,actor_icemonster),3,Rand(0,3))
				typ_spawner_create(Rand(actor_orc,actor_icemonster),6,Rand(0,3))
				typ_spawner_create(Rand(actor_orc,actor_icemonster),9,Rand(0,3))
				typ_spawner_create(Rand(actor_orc,actor_icemonster),12,Rand(0,3))				
				
			Case 6
				
				
								;LEVEL SIX - TREASURY (3:00-3:30)
				;Dark Elf guarded by skeletons And guards (Melee)
				
				typ_spawner_create(actor_darkelf,1,1,1)
				typ_spawner_create(actor_skeleton,2,0)
				typ_spawner_create(actor_guard,4,1)
				typ_spawner_create(actor_skeleton,6,2)
				typ_spawner_create(actor_guard,8,3)
				
			Case 7
				
				;LEVEL EIGHT - FINAL Exit (4:00-4:45)
				;Ice Guard Boss
				
				typ_spawner_create(actor_iceguard,1,1,1)
				
		End Select
	
End Function

Function limitvalue#(val#,min#,max#)
	
	If val# < min Then Return min#
	If val# > max Then Return max#
	Return val#
	
End Function

Function wrapvalue#(val#,min#,max#)
	
	If val# < min Then Return max#
	If val# > max Then Return min#
	Return val#
	
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D